/*
 *   DIS/x : An implementation of the IEEE 1278.1 protocol
 *
 *   Copyright (C) 1997, Riley Rainey (rrainey@ix.netcom.com)
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of either:
 *
 *   a) the GNU Library General Public License as published by the Free
 *   Software Foundation; either version 2 of the License, or (at your
 *   option) any later version.  A description of the terms and conditions
 *   of the GLPL may be found in the "COPYING.LIB" file.
 *
 *   b) the "Artistic License" which comes with this Kit.  Information
 *   about this license may be found in the "Artistic" file.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Library General Public License or the Artistic License for more details.
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this library; if not, write to the Free
 *   Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *   Information describing how to contact the author can be found in the
 *   README file.
 */

#define PDUTypeOther			0
#define PDUTypeEntityState		1
#define PDUTypeFire			2
#define PDUTypeDetonation		3
#define PDUTypeCollision		4
#define PDUTypeServiceRequest		5
#define PDUTypeResupplyOffer		6
#define PDUTypeResupplyReceived		7
#define PDUTypeResupplyCancel		8
#define PDUTypeRepairComplete		9
#define PDUTypeRepairResponse		10
#define PDUTypeCreateEntity		11
#define PDUTypeRemoveEntity		12
#define PDUTypeStartResume		13
#define PDUTypeStopFreeze		14
#define PDUTypeAcknowledge		15
#define PDUTypeActionRequest		16
#define PDUTypeActionResponse		17
#define PDUTypeDataQuery		18
#define PDUTypeSetData			19
#define PDUTypeData			20
#define PDUTypeEventReport		21
#define PDUTypeMessage			22
#define PDUTypeEmission			23
#define PDUTypeLaser			24
#define PDUTypeTransmitter		25
#define PDUTypeSignal			26
#define PDUTypeReceiver			27

typedef enum {
	DISProtocolVersionMay92	=	1,
	DISProtocolVersionIEEE1278_93 =	2,
	DISProtocolVersionMay93	=	3,
	DISProtocolVersion2_04	=	4,
	DISProtocolVersionIEEE1278_95 = 5
	} DISProtocolVersion;

typedef enum {
	DISForceOther     = 0,
	DISForceFriendly  = 1,
	DISForceOpposing  = 2,
	DISForceNeutral   = 3
	} DISForce;

