/*
 *   DIS/x : An implementation of the IEEE 1278.1 protocol
 *
 *   Copyright (C) 1996, Riley Rainey (rainey@netcom.com)
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of either:
 *
 *   a) the GNU Library General Public License as published by the Free
 *   Software Foundation; either version 2 of the License, or (at your
 *   option) any later version.  A description of the terms and conditions
 *   of the GLPL may be found in the "COPYING.LIB" file.
 *
 *   b) the "Artistic License" which comes with this Kit.  Information
 *   about this license may be found in the "Artistic" file.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Library General Public License or the Artistic License for more details.
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this library; if not, write to the Free
 *   Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *   Information describing how to contact the author can be found in the
 *   README file.
 */
#include <server.h>
#include <malloc.h>
#include <string.h>
#ifdef HAVE_NDBM
#include <ndbm.h>
#else
#include <sdbm.h>
#endif

DBM *sites;
static unsigned short site = 0xfffd;

simx_site_info *head = 0, *tail = 0;

simx_site_info *
LocateSiteByName (char * name)
{
	simx_site_info *p;

	for (p = head; p; p = p->next) {
		if (strcmp (p->name, name) == 0) {
			return p;
		}
	}

/*
 *  Not found.  Allocate a new information node.
 */

	p = (simx_site_info *) malloc (sizeof (simx_site_info));
	p->next = NULL;
	if (tail) {
		tail->next = p;
	}
	tail = p;
	if (!head) {
		head = p;
	}
	p->name = strdup (name);
	p->application_id = 0xfffd;
	p->site_id = site--;
	return p;
}
